SUBROUTINE RELAX(ALF,XEXT,XP,X,IX,KMAX)
!***BEGIN PROLOGUE RELAX
!***AUTHOR
!         RELAX written by DNMI (Engedal?)
!         Revised 911003 by J.Berntsen by introducing
!         parameter list.
!         Modified 130499 by Inge K Eliassen: FRS on all edges (and corners)
!         MODIFIED 130799 by J.Berntsen by using FRS-arrays covering the 
!         whole region
!
!***********************************************************************
!
!
!-----------------------------------------------------------------------
!   UPDATES VALUES OF THE VARIABLE X IN THE BOUNDARY ZONES USING
!   THE FLOW RELAXATION SCHEME (FRS) :
!
!   X(N+1) = ALFA*( XEXT(N+1)+XP(N+1) ) + (1-ALFA)*X(N+1)
!-----------------------------------------------------------------------
!***END PROLOGUE RELAX
!
!   Global integers.
!
USE MOD_BOUND
IMPLICIT NONE
INTEGER KMAX,IX
!
!   Global reals.
!
REAL ALF(LB),XEXT(IM,JM,KMAX),XP(IM,JM,KMAX),X(IM,JM,KMAX)
!
!   Local variables.
!
INTEGER I,J,K,IFRS
!
!     -------  BOUNDARY ZONE WEST 
!  For the Osteroy case only opening towards west for
! J = 13,14
!
IF(IX.EQ.2) THEN
! U-points:
   DO K=1,KMAX
!     DO J=1,JM
      DO J = 13,14
         X(1,J,K)=XEXT(1,J,K)+XP(1,J,K)
         DO I = 2,LB
            IF (J.LE.LB) THEN
              IFRS = MIN(I-1,J)
            ELSEIF (J.GE.JM-LB) THEN
              IFRS = MIN(I-1,JM+1-J)
            ELSE
              IFRS = I-1
            ENDIF
            X(I,J,K)=ALF(IFRS)*(XEXT(I,J,K)+XP(I,J,K)) &
                 &          +((1.0-ALF(IFRS))*X(I,J,K))
         END DO
      END DO
   END DO
ELSE
   ! V-points / EL-points
   DO K=1,KMAX
      DO I=1,LB
!        DO J=1,JM
         DO J = 13,14
            IF (J.LE.LB) THEN
              IFRS = MIN(I,J)
            ELSEIF (J.GE.JM-LB) THEN
              IFRS = MIN(I,JM+1-J)
            ELSE
              IFRS = I
            ENDIF
            X(I,J,K)=ALF(IFRS)*(XEXT(I,J,K)+XP(I,J,K))+ &
                 &          ((1.0-ALF(IFRS))*X(I,J,K))
         END DO
      END DO
   END DO
ENDIF
!
!     -------  BOUNDARY ZONE EAST
!  For the Osteroy case the east boundary is closed
!
! U- or V- or EL-points
!DO K=1,KMAX
!   DO I=IM-LB+1,IM
!      DO J=1,JM
!        IF (J.LE.LB) THEN
!          IFRS = MIN(IM+1-I,J)
!        ELSEIF (J.GE.JM-LB) THEN
!          IFRS = MIN(IM+1-I,JM+1-J)
!        ELSE
!          IFRS = IM+1-I
!        ENDIF
!        X(I,J,K)=ALF(IFRS)*(XEXT(I,J,K)+XP(I,J,K))+ &
!        &          ((1.0-ALF(IFRS))*X(I,J,K))
!      END DO
!   END DO
!END DO
!
!     -------  BOUNDARY ZONE SOUTH
! For the Osteroy case the south boundary is open for
!  I = 15,18
!
IF (IX == 3) THEN
   ! V-points:
   DO K=1,KMAX
!     DO I=LB+1,IM-LB
      DO I = 15,18
         X(I,1,K)=XEXT(I,1,K)+XP(I,1,K)
         DO J=2,LB
            IFRS = J-1
            X(I,J,K)=ALF(IFRS)*(XEXT(I,J,K)+XP(I,J,K)) &
                 &          +((1.0-ALF(IFRS))*X(I,J,K))
         END DO
      END DO
   END DO
ELSE
   ! U-points / EL-points
   DO K=1,KMAX
!     DO I=LB+1,IM-LB
      DO I = 15,18
         DO J=1,LB
            IFRS = J
            X(I,J,K)=ALF(IFRS)*(XEXT(I,J,K)+XP(I,J,K)) &
                 &          +((1.0-ALF(IFRS))*X(I,J,K))
         END DO
      END DO
   END DO
END IF

!
!     -------  BOUNDARY ZONE NORTH
!  For the Osteroy case the north boundary is closed
!
! U- or V- or EL-points
!DO K=1,KMAX
!   DO I=LB+1,IM-LB
!      DO J=JM-LB+1,JM
!         IFRS = JM+1-J
!            X(I,J,K)=ALF(IFRS)*(XEXT(I,J,K)+XP(I,J,K)) &
!                 &          +((1.0-ALF(IFRS))*X(I,J,K))
!      END DO
!   END DO
!END DO
!
RETURN
END SUBROUTINE RELAX
