SUBROUTINE SMAGOR
USE STATE
IMPLICIT NONE
!
!   Local variables.
!
INTEGER I,J,K
REAL AMLIM
AMLIM = 0.0625*DX**2/DT
AM = 0.
!
!$OMP PARALLEL DO PRIVATE(I,J,K) FIRSTPRIVATE(DX,DY,CM)
DO J = 2,JM-1
  DO I = 2,IM-1
    IF (FSM(I,J).GT.0.) THEN
      DO K = 1,KB-1
        AM(I,J,K)=CM*DX*DY*SQRT(((U(I+1,J,K)-U(I,J,K))/DX)**2 &
     &        +((V(I,J+1,K)-V(I,J,K))/DY)**2 &
     &     +.5*(.25*(U(I,J+1,K)+U(I+1,J+1,K)- &
     &U(I,J-1,K)-U(I+1,J-1,K))/DY    &
     &     + .25*(V(I+1,J,K)+V(I+1,J+1,K)- &
     &V(I-1,J,K)-V(I-1,J+1,K))/DX)**2)
      END DO
    ENDIF
  END DO
END DO
IF (CM.GT.0.) THEN
  AH = (CH/CM)*AM
ELSE
  AH = 0.
ENDIF 
!$OMP PARALLEL DO PRIVATE(I,J,K)
DO J = 2,JM-1
  DO I = 2,IM-1
    IF (FSM(I,J).GT.0.) THEN
      DO K = 1,KB-1
        AM(I,J,K) = MIN(AM(I,J,K),AMLIM)
        AH(I,J,K) = MIN(AH(I,J,K),AMLIM)
      END DO
    ENDIF
  END DO
END DO
!
!
RETURN
END
