SUBROUTINE STEPV2D(DTE,AY,C2V)
  USE STATE
  IMPLICIT NONE
  REAL DTE
  REAL AY(IM,JM),C2V(IM,JM),UV2D(IM,JM),CORV(IM,JM)
  INTEGER I,J
!
!Define U*D in V-points.
!
!DO J = 2,JM
!   DO I = 2,IM-1
!      UV2D(I,J) = 0.25*(DU(I+1,J)*UA(I+1,J)+DU(I,J)*UA(I,J)+&
!           & DU(I+1,J-1)*UA(I+1,J-1)+DU(I,J-1)*UA(I,J-1))
!   END DO
!END DO
  UV2D = 0.

!$omp parallel do
  DO J = 2,JM
     DO I = 2,IM-1
        IF (DVM(I,J).NE.0.) THEN
           IF (DUM(I+1,J).NE.0.) THEN
              UV2D(I,J) = UA(I+1,J)*DU(I+1,J)/HUSQR(I+1,J)
           ENDIF
           IF (DUM(I,J).NE.0.) THEN
              UV2D(I,J) = UV2D(I,J) + UA(I,J)*DU(I,J)/HUSQR(I,J)
           ENDIF
           IF (DUM(I+1,J-1).NE.0.) THEN
              UV2D(I,J) = UV2D(I,J) + UA(I+1,J-1)*DU(I+1,J-1)/HUSQR(I+1,J-1)
           ENDIF
           IF (DUM(I,J-1).NE.0.) THEN
              UV2D(I,J) = UV2D(I,J) + UA(I,J-1)*DU(I,J-1)/HUSQR(I,J-1)
           ENDIF
           UV2D(I,J) = 0.25*UV2D(I,J)*HVSQR(I,J)
        ENDIF
     END DO
  END DO

!
!Propagate the solution taking all terms into account.
!
!$omp parallel do firstprivate(dy)
  DO J = 2,JM
     DO I = 2,IM-1
        CORV(I,J) = -COR(I,J)*UV2D(I,J) - GRAV*DV(I,J)* &
             &  (ETA(I,J)-ETA(I,J-1))/DY + AY(I,J) + C2V(I,J)
     END DO
  END DO

!$omp parallel do firstprivate(dte)
  DO J = 2,JM
     DO I = 2,IM-1
        IF (DVM(I,J).NE.0.) THEN
           VA(I,J) = VA(I,J) + DTE*CORV(I,J)/DV(I,J)
        ENDIF
     END DO
  END DO
!
END SUBROUTINE STEPV2D
