SUBROUTINE WREAL
USE STATE
IMPLICIT NONE
!***BEGIN PROLOGUE WREAL
!***REVISION DATE 300196
!
!***AUTHOR
!
!     Revised by 
!
!            Jarle Berntsen, Department of Mathematics
!
!***PURPOSE WREAL computes the real vertical velocity, WR.
!
!***ROUTINES CALLED NONE
!***END PROLOGUE WREAL
!
REAL, DIMENSION(IM,JM,KB) :: ZLEV
!
!   Local variables.
!
INTEGER I,J,K
REAL DXR,DYT,DTI
!
!
DXR = 1./DX
DYT = 1./DY
DTI = 1./DT
!
WR = 0.
!
!   Adjust WR by taking into account the
!   gradient of the sigma-surfaces.
!
DO K = 1,KB-1
  DO J = 1,JM
    DO I = 1,IM
      ZLEV(I,J,K)=ZZ(K)*D(I,J) + ETA(I,J)
    END DO
  END DO
!
  DO J = 2,JM-1
    DO I = 2,IM-1
      WR(I,J,K)=0.5*(W(I,J,K)+W(I,J,K+1)) + 0.5* &
     &   ( U(I+1,J,K)*(ZLEV(I+1,J,K)-ZLEV(I,J,K))*DXR  + &
     &     U(I,J,K)*(ZLEV(I,J,K)-ZLEV(I-1,J,K))*DXR    + &
     &     V(I,J+1,K)*(ZLEV(I,J+1,K)-ZLEV(I,J,K))*DYT  + &
     &     V(I,J,K)*(ZLEV(I,J,K)-ZLEV(I,J-1,K))*DYT  ) + &
     &    (1.+ZZ(K))*(ETA(I,J)-ETAP(I,J))*DTI
       WR(I,J,K) = WR(I,J,K)*FSM(I,J)
    END DO
  END DO
END DO
!
!
RETURN
END
